GotLThad = {};

GotLThad.Lock = 0;
GotLThad.Check = 0;
GotLThad.Combat = 1;
GotLThad.LastPol = 0;
GotLThad.StartPol = 2;
GotLThad.Scale = 1;

GotLThad.CAST_POL		= "Thaddius begins to cast Polarity Shift.";
GotLThad.YELL_START1	= "Kill...";
GotLThad.YELL_START2	= "Eat... your... bones...";
GotLThad.YELL_START3	= "Break... you!!";


GotLThad.polshiftsound = "Interface\\AddOns\\Guardians_Thad\\charge.wav";
GotLThad.movesound = "Interface\\AddOns\\Guardians_Thad\\siren.wav";

function GotLThad:OnLoad()
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");	
	this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE");
	this:RegisterEvent("CHAT_MSG_MONSTER_YELL");		
	
	GotLThadFrame:SetScale(1);
	
	SLASH_GotLThad1 = "/gthad";
	SlashCmdList["GotLThad"] = GotLThad_SlashHandler;
	GotLThadTexture:SetTexture("Interface\\Icons\\Spell_ChargeNegative");
	GotLThad.Combat = 0;
	GotLThad.LastPol = 2;
	GotLThad.StartPol = 2;							
	GotLThadFrame:SetHeight(GotLThad.Scale * 50);
	GotLThadFrame:SetWidth(GotLThad.Scale * 50);	
end

function GotLThad:OnMouseWheel(value)
	if (IsShiftKeyDown()) then
		--local ftop = GotLThadFrame:GetTop();
		--local fleft = GotLThadFrame:GetLeft();
		--DEFAULT_CHAT_FRAME:AddMessage("t/l "..ftop.." "..fleft, 1,1,1);			
		--GotLThadFrame:ClearAllPoints();	
		
		if ( value > 0 ) then 
			GotLThad.Scale = GotLThad.Scale + 0.1;
 		elseif ( value < 0 ) then 
 			GotLThad.Scale = GotLThad.Scale - 0.1;
 		end
 		GotLThadFrame:SetHeight(GotLThad.Scale * 50);
 		GotLThadFrame:SetWidth(GotLThad.Scale * 50);
 		--ftop = ftop / GotLThad.Scale;
		--DEFAULT_CHAT_FRAME:AddMessage("t/l "..ftop.." "..fleft, 1,1,1);			 				
 		--GotLThadFrame:SetPoint("TOPLEFT",GotLThadFrame:GetParent(), "TOPLEFT", 100,-100);
  else
  end
end


function GotLThad:SetPol(pol)
	if (GotLThad.Combat == 1) then
		DEFAULT_CHAT_FRAME:AddMessage("Locked ! You are in Combat !", 1,1,1);			
		return;
	end
	if (pol ==1) then
		GotLThad.Check = 1;		
		GotLThadTexture:SetTexture("Interface\\Icons\\Spell_ChargePositive");
		GotLThad.LastPol = 1;
		GotLThad.StartPol = 1;
		DEFAULT_CHAT_FRAME:AddMessage("Polarity will start positive", 1,1,1);			
	elseif (pol == 2) then
		GotLThad.Check = 1;		
		GotLThadTexture:SetTexture("Interface\\Icons\\Spell_ChargeNegative");
		GotLThad.LastPol = 2;
		GotLThad.StartPol = 2;						
		DEFAULT_CHAT_FRAME:AddMessage("Polarity will start negative", 1,1,1);			
	else
		GotLThad.Check = 1;		
		GotLThadTexture:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark");			
		GotLThad.LastPol = 0;
		GotLThad.StartPol = 0;						
		DEFAULT_CHAT_FRAME:AddMessage("Polarity will start undefined", 1,1,1);					
	end
end


function GotLThad:OnClick(arg1)
	--DEFAULT_CHAT_FRAME:AddMessage("Clk", 0,1,0);
	if (IsShiftKeyDown()) then
		if(arg1 == "RightButton") then
			GotLThad:SetPol(1);  
		else
			GotLThad:SetPol(2);	
		end		
	elseif (IsAltKeyDown()) then
		GotLThad:Reset();
  end	
end

function GotLThad:ResetPos()
	GotLThadFrame:ClearAllPoints();
	GotLThad.Scale = 1;
	GotLThadFrame:SetScale(1);
	GotLThadFrame:SetHeight(GotLThad.Scale * 50);
 	GotLThadFrame:SetWidth(GotLThad.Scale * 50);
	
	GotLThadFrame:SetPoint("TOPLEFT",GotLThadFrame:GetParent(), "TOPLEFT", 100, -100);
end

function GotLThad_SlashHandler(arg1)
	if (string.lower(arg1) == "on") then
		GotLThad.Check = 1;
		GotLThadFrame:Show();
		DEFAULT_CHAT_FRAME:AddMessage("GotLThad enabled", 0,1,0);
	elseif (string.lower(arg1) == "off") then
		GotLThad.Check = 0;
		GotLThadFrame:Hide();
		DEFAULT_CHAT_FRAME:AddMessage("GotLThad disabled", 0,1,0);
	elseif (string.lower(arg1) == "lock") then
		GotLThad.Lock =1;
		DEFAULT_CHAT_FRAME:AddMessage("Graphic locked", 0,1,0);
	elseif (string.lower(arg1) == "unlock") then
		GotLThad.Lock =0;
		DEFAULT_CHAT_FRAME:AddMessage("Graphic unlocked", 0,1,0);
	elseif (string.lower(arg1) == "reset") then
		GotLThad.Combat = 0;
		GotLThad:Reset();
	elseif (string.lower(arg1) == "ts1") then
		PlaySoundFile(GotLThad.movesound);
		DEFAULT_CHAT_FRAME:AddMessage("Polarity has changed ! Move !", 1,0,0);									
	elseif (string.lower(arg1) == "ts2") then
		PlaySoundFile(GotLThad.polshiftsound);
		DEFAULT_CHAT_FRAME:AddMessage("Polarity Changing", 1,1,1);	
	elseif (string.lower(arg1) == "setp") then
		GotLThad:SetPol(1);
	elseif (string.lower(arg1) == "setn") then
		GotLThad:SetPol(2);
	elseif (string.lower(arg1) == "setu") then
		GotLThad:SetPol(0);
	elseif (string.lower(arg1) == "big") then
		GotLThad.Scale = 1.5;
		GotLThadFrame:SetHeight(GotLThad.Scale * 50);
 		GotLThadFrame:SetWidth(GotLThad.Scale * 50);
	elseif (string.lower(arg1) == "norm") then
		GotLThad.Scale = 1;
		GotLThadFrame:SetHeight(GotLThad.Scale * 50);
 		GotLThadFrame:SetWidth(GotLThad.Scale * 50);
	elseif (string.lower(arg1) == "small") then
		GotLThad.Scale = 0.5;
		GotLThadFrame:SetHeight(GotLThad.Scale * 50);
 		GotLThadFrame:SetWidth(GotLThad.Scale * 50);
	elseif (string.lower(arg1) == "help") then
		DEFAULT_CHAT_FRAME:AddMessage("GotLThad commands on|off lock|unlock ts1|ts2 setp|setn big|norm|small reset resetpos", 0,1,0);
	elseif (string.lower(arg1) == "resetpos") then		
		GotLThad:ResetPos()
	else
		if (GotLThad.Check ==0) then
			GotLThad.Check = 1;
			GotLThadFrame:Show();
			DEFAULT_CHAT_FRAME:AddMessage("GotLThad enabled", 0,1,0);
		else
			GotLThad.Check = 0;
			GotLThadFrame:Hide();
			DEFAULT_CHAT_FRAME:AddMessage("GotLThad disabled", 0,1,0);
		end	
	end
end

function GotLThad:OnEvent(event)
	if (GotLThad.Check == 1) then
		if (event == "PLAYER_REGEN_DISABLED") then
			GotLThad.Combat = 1;
		elseif (event == "PLAYER_REGEN_ENABLED") then
			GotLThad.Combat = 0;
		elseif (event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE") then
			if arg1 == GotLThad.CAST_POL then
				PlaySoundFile(GotLThad.polshiftsound);
				DEFAULT_CHAT_FRAME:AddMessage("Polarity Changing", 1,1,1);	
			end
		elseif (event == "CHAT_MSG_MONSTER_YELL") then
			if (arg1 == GotLThad.YELL_START1) or (arg1 == GotLThad.YELL_START2) or (arg1 == GotLThad.YELL_START3) then
				GotLThad.Combat = 0;
				GotLThad:Reset();
				GotLThad.Combat = 1;
			end	
		end
	end
end

function GotLThad:Reset()
	if (GotLThad.Combat == 1) then
		DEFAULT_CHAT_FRAME:AddMessage("Locked ! You are in Combat !", 1,1,1);			
		return;
	end
	if (GotLThad.StartPol == 1) then
		GotLThadTexture:SetTexture("Interface\\Icons\\Spell_ChargePositive");
		GotLThad.LastPol = 1;					
		DEFAULT_CHAT_FRAME:AddMessage("Polarity start positive", 1,1,1);	
	elseif (GotLThad.StartPol == 2) then
		GotLThadTexture:SetTexture("Interface\\Icons\\Spell_ChargeNegative");
		GotLThad.LastPol = 2;		
		DEFAULT_CHAT_FRAME:AddMessage("Polarity start negative", 1,1,1);	
	else
		GotLThadTexture:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark");			
		GotLThad.LastPol = 0;		
		DEFAULT_CHAT_FRAME:AddMessage("Polarity start unknown", 1,1,1);						
	end		
	GotLThadFrame:Show();
	GotLThad.Check = 1;				
	DEFAULT_CHAT_FRAME:AddMessage("Thaddius reseted", 0,1,0);					
end

function GotLThad:OnUpdate(arg1)
	if (GotLThad.Check == 1) then
		for a=1,16 do
			local t,c = UnitDebuff("player",a);
			if(t == nil) then
				break; 
			elseif(t == "Interface\\Icons\\Spell_ChargePositive") then
					GotLThadTexture:SetTexture("Interface\\Icons\\Spell_ChargePositive");
					if (GotLThad.LastPol == 2) then
						PlaySoundFile(GotLThad.movesound);
						DEFAULT_CHAT_FRAME:AddMessage("Polarity has changed ! Move !", 1,0,0);									
					end
					GotLThad.LastPol = 1;
					break;
			elseif(t == "Interface\\Icons\\Spell_ChargeNegative") then
					GotLThadTexture:SetTexture("Interface\\Icons\\Spell_ChargeNegative");
					if (GotLThad.LastPol == 1) then
						PlaySoundFile(GotLThad.movesound);
						DEFAULT_CHAT_FRAME:AddMessage("Polarity has changed ! Move !", 1,0,0);									
					end					
					GotLThad.LastPol = 2;
					break;
			end
		end
	end
end


